image: registry.gitlab.com/zredalmeria/openzmeter/openwrt_nanopi_air

stages:
  - build

build:
  stage: build
  tags:
    - devel
  cache:
    paths:
      - Service/WEB/node_modules
  artifacts:
    paths:
      - Service/Tmp/openZmeter*.ipk
  script:
    - export BUILD_DATE=$(date -d @$(git show -s --format=%ct $CI_COMMIT_SHA) +%Y%m%d.%H%M)
    - export BUILD_NAME=$CI_COMMIT_REF_NAME
    - cd Service
    - make CONFIG=Configs/openWRT_nanoPI-AIR -j8
    - cd Tmp   
    - mkdir -p Package
    - mkdir -p Package/usr/sbin
    - mv openZmeter Package/usr/sbin/
    - mkdir -p Package/CONTROL
    - |
      cat > Package/CONTROL/control << EOF
      Package: openZmeter-${BUILD_NAME}
      Version: ${BUILD_DATE}
      Section: base
      Priority: optional
      Architecture: arm_cortex-a7_neon-vfpv4
      Depends: fftw3f (>= 3.3.7), libusb-1.0 (>= 1.0.22), libpq (>= 9.6.6), libopenssl (>= 1.0), bluez-daemon (>= 5.49)
      Maintainer: Eduardo Viciana <eviciana@zred.es>
      Description: Power quality/mettering and analysis tool.
      Source: https://gitlab.com/zredalmeria/openzmeter
      EOF
    - |
      cat > Package/CONTROL/postinst << EOF
      if [ ! -d "/usr/share/zoneinfo" ]; then
        ln -s /usr/share/postgresql/timezone /usr/share/zoneinfo
      fi
      /etc/init.d/openZmeter enable
      /etc/init.d/openZmeter restart
      EOF
    - chmod +x Package/CONTROL/postinst
    - mkdir -p Package/etc/init.d
    - |  
      cat > Package/etc/init.d/openZmeter << EOF
      #!/bin/sh /etc/rc.common
      #start after dbus (60)
      START=80
      USE_PROCD=1
      start_service() {
        procd_open_instance
        procd_set_param command "/usr/sbin/openZmeter"
        procd_set_param respawn
        procd_close_instance
      }
      EOF
    - chmod +x Package/etc/init.d/openZmeter
    - ipkg-build -o root -g root Package .
